﻿using System;
using System.Windows.Forms;
using System.IO.Ports;
namespace XV_11
{

    public partial class FormConfig : Form
    {
    
        EZ_Builder.Config.Sub.PluginV1 _cf;
        /// <summary>
        /// Form Config 
        /// </summary>
        /// <param name="cf"></param>
        public FormConfig(EZ_Builder.Config.Sub.PluginV1 cf)
        {
            
            InitializeComponent();
            FillPortsList();

            _cf = cf;

        }
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public EZ_Builder.Config.Sub.PluginV1 GetConfig
        {
            get
            {
                return _cf;
            }
        }

        private void FormConfig_Load(object sender, EventArgs e)
        {
            EZ_Builder.Invokers.SetComboBoxSelectedIndex(cbImageRotation, Convert.ToInt32(_cf.STORAGE[ConfigDictionary.ImageRotation]));
            EZ_Builder.Invokers.SetComboBoxSelectedIndex(cbAngleStart, Convert.ToInt32(_cf.STORAGE[ConfigDictionary.StartAngle]));
            EZ_Builder.Invokers.SetComboBoxSelectedIndex(cbAngleStop, Convert.ToInt32(_cf.STORAGE[ConfigDictionary.StopAngle]));
            EZ_Builder.Invokers.SetComboBoxSelectedIndex(cbBufferSize, Convert.ToInt32(_cf.STORAGE[ConfigDictionary.BufferSize]));//2048 default
            EZ_Builder.Invokers.SetChecked(ckGThan, Convert.ToBoolean(_cf.STORAGE[ConfigDictionary.gtChecked]));
            EZ_Builder.Invokers.SetChecked(ckLThan, Convert.ToBoolean(_cf.STORAGE[ConfigDictionary.gtChecked]));
            EZ_Builder.Invokers.SetComboBoxSelectedIndex(cbMapZoom, Convert.ToInt32(_cf.STORAGE[ConfigDictionary.mapzoom]));
            EZ_Builder.Invokers.SetComboBoxSelectedIndex(cbMapBackground, Convert.ToInt32(_cf.STORAGE[ConfigDictionary.background]));
            EZ_Builder.Invokers.SetComboBoxSelectedIndex(cbPointColor, Convert.ToInt32(_cf.STORAGE[ConfigDictionary.thePen]));
            EZ_Builder.Invokers.SetComboBoxSelectedIndex(cbMapPoint2, Convert.ToInt32(_cf.STORAGE[ConfigDictionary.thePen2]));
            EZ_Builder.Invokers.SetComboBoxSelectedIndex(cbMapPoint3, Convert.ToInt32(_cf.STORAGE[ConfigDictionary.thePen3]));
            EZ_Builder.Invokers.SetComboBoxSelectedIndex(cbIntensity1, Convert.ToInt32(_cf.STORAGE[ConfigDictionary.thePenI1]));
            EZ_Builder.Invokers.SetComboBoxSelectedIndex(cbIntensity2, Convert.ToInt32(_cf.STORAGE[ConfigDictionary.thePenI2]));
            EZ_Builder.Invokers.SetComboBoxSelectedIndex(cbIntensity3, Convert.ToInt32(_cf.STORAGE[ConfigDictionary.thePenI3]));
            EZ_Builder.Invokers.SetComboBoxSelectedIndex(cbTextColor, Convert.ToInt32(_cf.STORAGE[ConfigDictionary.textcolor]));
            EZ_Builder.Invokers.SetComboBoxSelectedIndex(cbLineColor, Convert.ToInt32(_cf.STORAGE[ConfigDictionary.LineColor]));
            EZ_Builder.Invokers.SetChecked(ckDrawLines, Convert.ToBoolean(_cf.STORAGE[ConfigDictionary.DrawLines]));
            EZ_Builder.Invokers.SetText(txtVar1, Convert.ToString(_cf.STORAGE[ConfigDictionary.Var1]));
            EZ_Builder.Invokers.SetText(cbTextColor, Convert.ToInt32(_cf.STORAGE[ConfigDictionary.textcolor]));
            EZ_Builder.Invokers.SetText(cbLineColor, Convert.ToInt32(_cf.STORAGE[ConfigDictionary.LineColor]));
            EZ_Builder.Invokers.SetComboBoxSelectedItem(cbCOMPort, Convert.ToString(_cf.STORAGE[ConfigDictionary.comportname]));

            cbImageRotation.SelectedItem = Convert.ToInt32(_cf.STORAGE[ConfigDictionary.ImageRotation]);
            cbBufferSize.SelectedItem = Convert.ToInt32(_cf.STORAGE[ConfigDictionary.BufferSize]);
            //cbCOMPort.SelectedItem = Convert.ToInt32(_cf.STORAGE[ConfigDictionary.comportname]);
            cbMapBackground.SelectedItem = Convert.ToInt32(_cf.STORAGE[ConfigDictionary.background]);
            cbPointColor.SelectedItem = Convert.ToInt32(_cf.STORAGE[ConfigDictionary.thePenI1]);
            cbMapPoint2.SelectedItem = Convert.ToInt32(_cf.STORAGE[ConfigDictionary.thePenI2]);
            cbMapPoint3.SelectedItem = Convert.ToInt32(_cf.STORAGE[ConfigDictionary.thePen3]);
            cbIntensity1.SelectedItem = Convert.ToInt32(_cf.STORAGE[ConfigDictionary.thePenI1]);
            cbIntensity2.SelectedItem = Convert.ToInt32(_cf.STORAGE[ConfigDictionary.thePenI2]);
            cbIntensity3.SelectedItem = Convert.ToInt32(_cf.STORAGE[ConfigDictionary.thePenI3]);
            cbTextColor.SelectedItem = Convert.ToInt32(_cf.STORAGE[ConfigDictionary.textcolor]);
            cbLineColor.SelectedItem = Convert.ToInt32(_cf.STORAGE[ConfigDictionary.LineColor]);
        }
            /// <summary>
             /// used to populate the list of com ports on the plugin screen.
             /// </summary>
        private void FillPortsList()
        {
            string[] ports = SerialPort.GetPortNames();
            foreach (string port in ports)
            {
                EZ_Builder.Invokers.SetItemAdd(cbCOMPort, port.Replace("\"", ""));
            }
            int x = 0;
            do
            {
                ComboboxItem item = new ComboboxItem();
                item.Text = x.ToString();
                item.Value = x;
                EZ_Builder.Invokers.SetItemAdd(cbAngleStart, item);
                EZ_Builder.Invokers.SetItemAdd(cbAngleStop, item);

                x++;
            } while (x < 360);
            int y = -90;
            do
            {
                ComboboxItem item = new ComboboxItem();
                item.Text = y.ToString();
                item.Value = y;
                EZ_Builder.Invokers.SetItemAdd(cbImageRotation, item);
                y++;
            } while (y < 91);
            int z = 64;
            do
            {
                ComboboxItem item = new ComboboxItem();
                item.Text = z.ToString();
                item.Value = z;
                EZ_Builder.Invokers.SetItemAdd(cbBufferSize, item);
                z = z + 64;
            } while (z < 8192);
            int w = 1;
            do
            {
                ComboboxItem item = new ComboboxItem();
                item.Text = w.ToString();
                item.Value = w;
                EZ_Builder.Invokers.SetItemAdd(cbMapZoom, item);
                w = w + 1;
            } while (w < 51);
            int v = 0;
            do
            {
                ComboboxItem item = new ComboboxItem();
                item.Text = v.ToString();
                item.Value = v;
                EZ_Builder.Invokers.SetItemAdd(cbIntensity1, item);
                EZ_Builder.Invokers.SetItemAdd(cbIntensity2, item);
                EZ_Builder.Invokers.SetItemAdd(cbIntensity3, item);
                v = v + 50;
            } while (v < 4001);
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            DialogResult = System.Windows.Forms.DialogResult.Cancel;
        }


        private void button2_Click_1(object sender, EventArgs e)
        {
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.ImageRotation, EZ_Builder.Invokers.GetComboBoxSelectedIndex(cbImageRotation).ToString());
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.ImageRotationValue, cbImageRotation.Text);
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.StartAngle, EZ_Builder.Invokers.GetComboBoxSelectedIndex(cbAngleStart).ToString());
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.StopAngle, EZ_Builder.Invokers.GetComboBoxSelectedIndex(cbAngleStop).ToString());
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.BufferSize, EZ_Builder.Invokers.GetComboBoxSelectedIndex(cbBufferSize).ToString());
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.BufferSizeValue, cbBufferSize.Text);
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.comportname, cbCOMPort.Text);
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.gtChecked, EZ_Builder.Invokers.GetCheckedValue(ckGThan).ToString());
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.mapzoom, EZ_Builder.Invokers.GetComboBoxSelectedIndex(cbMapZoom).ToString());
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.background, EZ_Builder.Invokers.GetComboBoxSelectedIndex(cbMapBackground).ToString());
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.backgroundcolor, cbMapBackground.Text);
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.thePen, EZ_Builder.Invokers.GetComboBoxSelectedIndex(cbPointColor).ToString());
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.thePenI1Color, cbPointColor.Text);
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.thePen2, EZ_Builder.Invokers.GetComboBoxSelectedIndex(cbMapPoint2).ToString());
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.thePenI2Color, cbMapPoint2.Text);
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.thePen3, EZ_Builder.Invokers.GetComboBoxSelectedIndex(cbMapPoint3).ToString());
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.thePen3Color, cbMapPoint3.Text);
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.thePenI1, EZ_Builder.Invokers.GetComboBoxSelectedIndex(cbIntensity1).ToString());
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.thePenI1Color, cbIntensity1.Text);
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.thePenI2, EZ_Builder.Invokers.GetComboBoxSelectedIndex(cbIntensity2).ToString());
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.thePenI2Color, cbIntensity2.Text);
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.thePenI3, EZ_Builder.Invokers.GetComboBoxSelectedIndex(cbIntensity3).ToString());
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.thePenI3Color, cbIntensity3.Text);
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.Var1, EZ_Builder.Invokers.GetText(txtVar1));
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.textcolor, EZ_Builder.Invokers.GetComboBoxSelectedIndex(cbTextColor).ToString());
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.textColorName, cbTextColor.Text);
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.DrawLines, EZ_Builder.Invokers.GetCheckedValue(ckDrawLines).ToString());
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.LineColor, EZ_Builder.Invokers.GetComboBoxSelectedIndex(cbLineColor).ToString());
            _cf.STORAGE.AddOrUpdate(ConfigDictionary.LineColorName, cbLineColor.Text);

            DialogResult = System.Windows.Forms.DialogResult.OK;
        }
    }
}
